# Material_Sandwich3D *GenData(sw_AssignMaterialToMacroelem,Int)

proc AssignMaterialToMacroelem { iLayer ICurrentMacrID } {

    set values [GiD_AccessValue get gendata "Layer"]
#   WarnWinText "Value= $values"

    set materialName [lindex $values [expr 3+4*($iLayer-1)]]
#    WarnWinText "MaterialName= $materialName"
#    WarnWinText "MaterialIndex= [expr 3+(4*$iLayer)]"
#    WarnWinText "ICurrentMacrID= $ICurrentMacrID"

#   GiD_AssignData material Reinforcement lines {[expr $iLayer*4]}

#   WarnWinText "AssignMaterialToMacroelem "
#   WarnWinText $materialName

    set nassigned [GiD_AssignData material $materialName volumes $ICurrentMacrID]

    if { $nassigned <= 0 } {
           set text "material $materialName can not be assigned to volumes $ICurrentMacrID nassigned = $nassigned"
        tk_messageBox -icon info -title [_ "WARNING:"] -type ok \
                      -message "$text"
#               WarnWinText "WARNING: material $materialName can not be assigned to volumes $ICurrentMacrID nassigned = $nassigned"
    }
}

proc Assign_Material_for_one_Sandwich3D { IndexMacroelement } {

    set osw_AssignMat [GiD_AccessValue get  gendata  "sw_AssignMaterialToMacroelem"]

    if { $osw_AssignMat == 1 } {

	# set layer_name "Assignment_Mat_S$IndexMacroelement"
	# GiD_Process layer new $layer_name escape

	#
	#  pocet vrstev *nLayers
	#

        set nLayers [Get_nLayers ]

	#
	#  cyklus pres vsechny vrstvy
	#

	for {set i 1} {$i<=$nLayers} {set i [expr $i+1]} {

		AssignMaterialToMacroelem $i $IndexMacroelement
		set IndexMacroelement [expr $IndexMacroelement+1]
	}

	# GiD_Process escape escape escape escape view layers delete $layer_name escape
    }
    return ""
}

proc Assign_Default_Material_for_Advanced_Frame { IndexMacroelement ToIndexMacroelement} {

    set nLayers [Get_nLayers ]

    set IndexMacroelement   [expr ($IndexMacroelement  -1)*$nLayers+1]
    set ToIndexMacroelement [expr ($ToIndexMacroelement-1)*$nLayers+1]

    for {set j $IndexMacroelement} {$j<=$ToIndexMacroelement} {set j [expr $j+$nLayers]} {
  	Assign_Material_for_one_Sandwich3D $j
    }
}

proc Assign_Aire_Material_for_Advanced_Frame { } {

    set nLayers [Get_nLayers ]

    if { $nLayers < 3 } {
    	return ""
    }

    set volume_list     [expr 5*$nLayers+2]
    lappend volume_list [expr 6*$nLayers+2]
    lappend volume_list [expr 7*$nLayers+2]
    lappend volume_list [expr 9*$nLayers+2]
    lappend volume_list [expr 10*$nLayers+2]
    lappend volume_list [expr 11*$nLayers+2]
#    lappend volume_list [expr 12*$nLayers+2]
    lappend volume_list [expr 13*$nLayers+2]
    lappend volume_list [expr 14*$nLayers+2]
    lappend volume_list [expr 15*$nLayers+2]
    lappend volume_list [expr 24*$nLayers+2]
    lappend volume_list [expr 25*$nLayers+2]
    lappend volume_list [expr 26*$nLayers+2]
    lappend volume_list [expr 37*$nLayers+2]
    lappend volume_list [expr 38*$nLayers+2]
    lappend volume_list [expr 39*$nLayers+2]
#    lappend volume_list [expr 40*$nLayers+2]
#    lappend volume_list [expr 41*$nLayers+2]
    lappend volume_list [expr 42*$nLayers+2]
    lappend volume_list [expr 61*$nLayers+2]
    lappend volume_list [expr 62*$nLayers+2]
    lappend volume_list [expr 63*$nLayers+2]
    lappend volume_list [expr 64*$nLayers+2]
    lappend volume_list [expr 65*$nLayers+2]
    lappend volume_list [expr 66*$nLayers+2]
    lappend volume_list [expr 85*$nLayers+2]
    lappend volume_list [expr 86*$nLayers+2]
    lappend volume_list [expr 87*$nLayers+2]
    lappend volume_list [expr 90*$nLayers+2]
    lappend volume_list [expr 93*$nLayers+2]
    lappend volume_list [expr 94*$nLayers+2]
    lappend volume_list [expr 95*$nLayers+2]
    lappend volume_list [expr 98*$nLayers+2]
    lappend volume_list [expr 100*$nLayers+2]
    lappend volume_list [expr 101*$nLayers+2]
    lappend volume_list [expr 102*$nLayers+2]
    lappend volume_list [expr 103*$nLayers+2]
    lappend volume_list [expr 106*$nLayers+2]
    lappend volume_list [expr 108*$nLayers+2]
    lappend volume_list [expr 109*$nLayers+2]
    lappend volume_list [expr 110*$nLayers+2]
    lappend volume_list [expr 111*$nLayers+2]
    lappend volume_list [expr 114*$nLayers+2]
    lappend volume_list [expr 116*$nLayers+2]
    lappend volume_list [expr 117*$nLayers+2]
    lappend volume_list [expr 118*$nLayers+2]
    lappend volume_list [expr 119*$nLayers+2]
    lappend volume_list [expr 122*$nLayers+2]
    lappend volume_list [expr 141*$nLayers+2]
    lappend volume_list [expr 142*$nLayers+2]
    lappend volume_list [expr 143*$nLayers+2]
    lappend volume_list [expr 144*$nLayers+2]
    lappend volume_list [expr 145*$nLayers+2]
    lappend volume_list [expr 146*$nLayers+2]

#    set volume_list "27 32 37 47 52 57 67 72 77 122 127 132 207 212 217 232 327 332 337 342 347 352 447 452 457 472 487 492 497 512 522 527 532 537 552 562 567 572 577 592 602 607 612 617 632 727 732 737 742 747 752"
    set Aire_Material_Name "Aire_around_Adhesive"
    Assign_Specific_Material $volume_list $Aire_Material_Name
}

proc Assign_Reinforcing_And_Adhesive_for_Advanced_Frame { } {

    set nLayers [Get_nLayers ]

    if { $nLayers < 4 } {
    	return ""
    }

#   oblast vyztuzeni ve smeru Y

    if { $nLayers > 1 } {
    	  set macroelement_list_reinf_Y     [expr 1*$nLayers-2]
    } else {
    	  set macroelement_list_reinf_Y     1
    }
    lappend macroelement_list_reinf_Y [expr 2*$nLayers-2]
    lappend macroelement_list_reinf_Y [expr 5*$nLayers-2]
    lappend macroelement_list_reinf_Y [expr 6*$nLayers-2]

    set oReinf_over_R_C [GiD_AccessValue get  gendata  "Reinf_over_R_C"]
    if {$oReinf_over_R_C==1} {
    	lappend macroelement_list_reinf_Y [expr  9*$nLayers-2]
    	lappend macroelement_list_reinf_Y [expr 10*$nLayers-2]
    }

#    set macroelement_list_reinf_Y "4 9 24 29"
    set Reinf_Y_Material_Name "Reinforced_Adhesive_Y"
    Assign_Specific_Material $macroelement_list_reinf_Y $Reinf_Y_Material_Name

#   oblast vyztuzeni ve smeru Z
    set macroelement_list_reinf_Z     [expr 28*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_Z [expr 29*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_Z [expr 36*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_Z [expr 37*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_Z [expr 44*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_Z [expr 45*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_Z [expr 52*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_Z [expr 53*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_Z [expr 60*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_Z [expr 61*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_Z [expr 68*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_Z [expr 69*$nLayers+($nLayers-2)]
#    set macroelement_list_reinf_Z "164 169 204 209 244 249 284 289 324 329 364 369"
    set Reinf_Z_Material_Name "Reinforced_Adhesive_Z"
    Assign_Specific_Material $macroelement_list_reinf_Z $Reinf_Z_Material_Name

#   oblast vyztuzeni ve smeru Y,Z a 45
    set macroelement_list_reinf_YZ     [expr 2*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 3*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 6*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 7*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 10*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 11*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 76*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 77*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 78*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 84*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 85*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 86*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 92*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 93*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 94*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 100*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 101*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 102*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 108*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 109*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_YZ [expr 110*$nLayers+($nLayers-2)]
    set oReinf_over_R_A [GiD_AccessValue get  gendata  "Reinf_over_R_A"]
    if {$oReinf_over_R_A==1} {
    	lappend macroelement_list_reinf_YZ [expr 10*$nLayers+($nLayers-2)]
    	lappend macroelement_list_reinf_YZ [expr 11*$nLayers+($nLayers-2)]
    	lappend macroelement_list_reinf_YZ [expr 108*$nLayers+($nLayers-2)]
    	lappend macroelement_list_reinf_YZ [expr 109*$nLayers+($nLayers-2)]
    	lappend macroelement_list_reinf_YZ [expr 110*$nLayers+($nLayers-2)]
    }
#    set macroelement_list_reinf_YZ "14 19 34 39 54 59 404 409 414 444 449 454 484 489 494 524 529 534 564 569 574"
    set Reinf_YZ45_Material_Name "Reinforced_Adhesive_YZ_and_45st"
    Assign_Specific_Material $macroelement_list_reinf_YZ $Reinf_YZ45_Material_Name

#   oblast vyztuzeni pouze ve smeru 45
    set macroelement_list_reinf_45st       [expr 10*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_45st   [expr 11*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_45st   [expr 78*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_45st   [expr 86*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_45st   [expr 94*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_45st   [expr 102*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_45st   [expr 108*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_45st   [expr 109*$nLayers+($nLayers-2)]
    lappend macroelement_list_reinf_45st   [expr 110*$nLayers+($nLayers-2)]
    if {$oReinf_over_R_A==1} {
    	lappend macroelement_list_reinf_45st [expr 14*$nLayers+($nLayers-2)]
    	lappend macroelement_list_reinf_45st [expr 15*$nLayers+($nLayers-2)]
    	lappend macroelement_list_reinf_45st [expr 116*$nLayers+($nLayers-2)]
    	lappend macroelement_list_reinf_45st [expr 117*$nLayers+($nLayers-2)]
    	lappend macroelement_list_reinf_45st [expr 118*$nLayers+($nLayers-2)]
    }
    set Reinf_45_Material_Name "Reinforced_Adhesive_45st_only"
    Assign_Specific_Material $macroelement_list_reinf_45st $Reinf_45_Material_Name

    if {$oReinf_over_R_A==1} {
    	set     macroelement_list_reinf_YZ [expr 10*$nLayers+($nLayers-2)]
    	lappend macroelement_list_reinf_YZ [expr 11*$nLayers+($nLayers-2)]
    	lappend macroelement_list_reinf_YZ [expr 108*$nLayers+($nLayers-2)]
    	lappend macroelement_list_reinf_YZ [expr 109*$nLayers+($nLayers-2)]
#    	lappend macroelement_list_reinf_YZ [expr 110*$nLayers+($nLayers-2)]
        set Reinf_YZ45_Material_Name "Reinforced_Adhesive_YZ_and_45st"
        Assign_Specific_Material $macroelement_list_reinf_YZ $Reinf_YZ45_Material_Name
    }
}

proc Assign_Specific_Material { macroelement_list material_name } {

    set nAssignment [llength $macroelement_list]

    for {set i 0} {$i < $nAssignment} {set i [expr $i+1]} {

       set ICurrentMacrID [lindex $macroelement_list $i]
       # WarnWinText "ICurrentMacrID=$ICurrentMacrID"

       set nassigned [GiD_AssignData material $material_name volumes $ICurrentMacrID]

       if { $nassigned <= 0 } {
	  set text "material $material_name can not be assigned to volumes $ICurrentMacrID nassigned = $nassigned, $macroelement_list"
	  tk_messageBox -icon info -title [_ "WARNING:"] -type ok \
	                -message "$text"
	#      WarnWinText "WARNING: material $material_name can not be assigned to volumes $ICurrentMacrID nassigned = $nassigned"
       }
    }
}